// file automatically generated by "../../../rheolef/fem/lib/basis_symbolic_cxx.cc"
///
/// This file is part of Rheolef.
///
/// Copyright (C) 2000-2009 Pierre Saramito <Pierre.Saramito@imag.fr>
///
/// Rheolef is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.
///
/// Rheolef is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.
///
/// You should have received a copy of the GNU General Public License
/// along with Rheolef; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
///
/// =========================================================================
#include "P0.h"
#include "piola_fem_lagrange.h"
namespace rheolef {
using namespace std;
template<class T>
class basis_P0_p {
public:
  typedef basis_rep<T>          base;
  typedef typename base::size_type size_type;
  static void evaluate      (const point_basic<T>& hat_x, Eigen::Matrix<T,Eigen::Dynamic,1>& values);
  static void grad_evaluate (const point_basic<T>& hat_x, Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values);
  static void hat_node  (Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>&);
};
template<class T>
class basis_P0_e {
public:
  typedef basis_rep<T>          base;
  typedef typename base::size_type size_type;
  static void evaluate      (const point_basic<T>& hat_x, Eigen::Matrix<T,Eigen::Dynamic,1>& values);
  static void grad_evaluate (const point_basic<T>& hat_x, Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values);
  static void hat_node  (Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>&);
};
template<class T>
class basis_P0_t {
public:
  typedef basis_rep<T>          base;
  typedef typename base::size_type size_type;
  static void evaluate      (const point_basic<T>& hat_x, Eigen::Matrix<T,Eigen::Dynamic,1>& values);
  static void grad_evaluate (const point_basic<T>& hat_x, Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values);
  static void hat_node  (Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>&);
};
template<class T>
class basis_P0_q {
public:
  typedef basis_rep<T>          base;
  typedef typename base::size_type size_type;
  static void evaluate      (const point_basic<T>& hat_x, Eigen::Matrix<T,Eigen::Dynamic,1>& values);
  static void grad_evaluate (const point_basic<T>& hat_x, Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values);
  static void hat_node  (Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>&);
};
template<class T>
class basis_P0_T {
public:
  typedef basis_rep<T>          base;
  typedef typename base::size_type size_type;
  static void evaluate      (const point_basic<T>& hat_x, Eigen::Matrix<T,Eigen::Dynamic,1>& values);
  static void grad_evaluate (const point_basic<T>& hat_x, Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values);
  static void hat_node  (Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>&);
};
template<class T>
class basis_P0_P {
public:
  typedef basis_rep<T>          base;
  typedef typename base::size_type size_type;
  static void evaluate      (const point_basic<T>& hat_x, Eigen::Matrix<T,Eigen::Dynamic,1>& values);
  static void grad_evaluate (const point_basic<T>& hat_x, Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values);
  static void hat_node  (Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>&);
};
template<class T>
class basis_P0_H {
public:
  typedef basis_rep<T>          base;
  typedef typename base::size_type size_type;
  static void evaluate      (const point_basic<T>& hat_x, Eigen::Matrix<T,Eigen::Dynamic,1>& values);
  static void grad_evaluate (const point_basic<T>& hat_x, Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values);
  static void hat_node  (Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>&);
};
template<class T>
void
basis_P0_p<T>::evaluate (
  const point_basic<T>& hat_x,
  Eigen::Matrix<T,Eigen::Dynamic,1>& values)
{
  values.resize(1);
  values[0] = 1.0;
}
template<class T>
void
basis_P0_p<T>::grad_evaluate (
  const point_basic<T>&                      hat_x,
  Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values)
{
  values.resize(1);
}
template<class T>
void
basis_P0_p<T>::hat_node (Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& x)
{
  x.resize(1);
  x[0] = point_basic<T>();
}
template<class T>
void
basis_P0_e<T>::evaluate (
  const point_basic<T>& hat_x,
  Eigen::Matrix<T,Eigen::Dynamic,1>& values)
{
  values.resize(1);
  values[0] = 1.0;
}
template<class T>
void
basis_P0_e<T>::grad_evaluate (
  const point_basic<T>&                      hat_x,
  Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values)
{
  values.resize(1);
  values[0][0] = 0.0;
}
template<class T>
void
basis_P0_e<T>::hat_node (Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& x)
{
  x.resize(1);
  x[0] = point_basic<T>(5.0000000000000000e-01);
}
template<class T>
void
basis_P0_t<T>::evaluate (
  const point_basic<T>& hat_x,
  Eigen::Matrix<T,Eigen::Dynamic,1>& values)
{
  values.resize(1);
  values[0] = 1.0;
}
template<class T>
void
basis_P0_t<T>::grad_evaluate (
  const point_basic<T>&                      hat_x,
  Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values)
{
  values.resize(1);
  values[0][0] = 0.0;
  values[0][1] = 0.0;
}
template<class T>
void
basis_P0_t<T>::hat_node (Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& x)
{
  x.resize(1);
  x[0] = point_basic<T>((1.0/3.0), (1.0/3.0));
}
template<class T>
void
basis_P0_q<T>::evaluate (
  const point_basic<T>& hat_x,
  Eigen::Matrix<T,Eigen::Dynamic,1>& values)
{
  values.resize(1);
  values[0] = 1.0;
}
template<class T>
void
basis_P0_q<T>::grad_evaluate (
  const point_basic<T>&                      hat_x,
  Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values)
{
  values.resize(1);
  values[0][0] = 0.0;
  values[0][1] = 0.0;
}
template<class T>
void
basis_P0_q<T>::hat_node (Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& x)
{
  x.resize(1);
  x[0] = point_basic<T>(0.0, 0.0);
}
template<class T>
void
basis_P0_T<T>::evaluate (
  const point_basic<T>& hat_x,
  Eigen::Matrix<T,Eigen::Dynamic,1>& values)
{
  values.resize(1);
  values[0] = 1.0;
}
template<class T>
void
basis_P0_T<T>::grad_evaluate (
  const point_basic<T>&                      hat_x,
  Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values)
{
  values.resize(1);
  values[0][0] = 0.0;
  values[0][1] = 0.0;
  values[0][2] = 0.0;
}
template<class T>
void
basis_P0_T<T>::hat_node (Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& x)
{
  x.resize(1);
  x[0] = point_basic<T>(2.5000000000000000e-01, 2.5000000000000000e-01, 2.5000000000000000e-01);
}
template<class T>
void
basis_P0_P<T>::evaluate (
  const point_basic<T>& hat_x,
  Eigen::Matrix<T,Eigen::Dynamic,1>& values)
{
  values.resize(1);
  values[0] = 1.0;
}
template<class T>
void
basis_P0_P<T>::grad_evaluate (
  const point_basic<T>&                      hat_x,
  Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values)
{
  values.resize(1);
  values[0][0] = 0.0;
  values[0][1] = 0.0;
  values[0][2] = 0.0;
}
template<class T>
void
basis_P0_P<T>::hat_node (Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& x)
{
  x.resize(1);
  x[0] = point_basic<T>((1.0/3.0), (1.0/3.0), 0.0);
}
template<class T>
void
basis_P0_H<T>::evaluate (
  const point_basic<T>& hat_x,
  Eigen::Matrix<T,Eigen::Dynamic,1>& values)
{
  values.resize(1);
  values[0] = 1.0;
}
template<class T>
void
basis_P0_H<T>::grad_evaluate (
  const point_basic<T>&                      hat_x,
  Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values)
{
  values.resize(1);
  values[0][0] = 0.0;
  values[0][1] = 0.0;
  values[0][2] = 0.0;
}
template<class T>
void
basis_P0_H<T>::hat_node (Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& x)
{
  x.resize(1);
  x[0] = point_basic<T>(0.0, 0.0, 0.0);
}
template<class T>
basis_P0<T>::basis_P0()
 : base(basis_option()), _hat_node()
{
  base::_sopt.set_continuous(false);
  _initialize_cstor_sizes();
  base::_name = "P0";
  base::_piola_fem.piola_fem<T>::base::operator= (new_macro(piola_fem_lagrange<T>));
}
template<class T>
basis_P0<T>::~basis_P0()
{
}
template<class T>
typename basis_P0<T>::size_type
basis_P0<T>::degree () const
{
    return 0;
}
template<class T>
void
basis_P0<T>::evaluate (
    reference_element     hat_K,
    const point_basic<T>& hat_x,
    Eigen::Matrix<T,Eigen::Dynamic,1>& values) const
{
    switch (hat_K.variant()) {
      case reference_element::p: {
        return basis_P0_p<T>::evaluate (hat_x, values);
      }
      case reference_element::e: {
        return basis_P0_e<T>::evaluate (hat_x, values);
      }
      case reference_element::t: {
        return basis_P0_t<T>::evaluate (hat_x, values);
      }
      case reference_element::q: {
        return basis_P0_q<T>::evaluate (hat_x, values);
      }
      case reference_element::T: {
        return basis_P0_T<T>::evaluate (hat_x, values);
      }
      case reference_element::P: {
        return basis_P0_P<T>::evaluate (hat_x, values);
      }
      case reference_element::H: {
        return basis_P0_H<T>::evaluate (hat_x, values);
      }
      default : {
        error_macro ("evaluate: unsupported `" << hat_K.name() << "' element type");
      }
    }
}
template<class T>
void
basis_P0<T>::grad_evaluate (
    reference_element        hat_K,
    const point_basic<T>&    hat_x,
    Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>& values) const
{
    switch (hat_K.variant()) {
      case reference_element::p: {
      return basis_P0_p<T>::grad_evaluate (hat_x, values);
      }
      case reference_element::e: {
      return basis_P0_e<T>::grad_evaluate (hat_x, values);
      }
      case reference_element::t: {
      return basis_P0_t<T>::grad_evaluate (hat_x, values);
      }
      case reference_element::q: {
      return basis_P0_q<T>::grad_evaluate (hat_x, values);
      }
      case reference_element::T: {
      return basis_P0_T<T>::grad_evaluate (hat_x, values);
      }
      case reference_element::P: {
      return basis_P0_P<T>::grad_evaluate (hat_x, values);
      }
      case reference_element::H: {
      return basis_P0_H<T>::grad_evaluate (hat_x, values);
      }
      default : {
        error_macro ("grad_evaluate: unsupported `" << hat_K.name() << "' element type");
      }
    }
}
template<class T>
void
basis_P0<T>::_compute_dofs (
  reference_element     hat_K,
  const Eigen::Matrix<T,Eigen::Dynamic,1>&   f_xnod,
        Eigen::Matrix<T,Eigen::Dynamic,1>&   dof) const
{
  dof = f_xnod;
}
template<class T>
void
basis_P0<T>::_initialize_cstor_sizes() const
{
  basis_fem_Pk_lagrange<T>::initialize_local_first (
    0,
    base::is_continuous(),
    base::_ndof_on_subgeo_internal,
    base::_ndof_on_subgeo,
    base::_nnod_on_subgeo_internal,
    base::_nnod_on_subgeo,
    base::_first_idof_by_dimension_internal,
    base::_first_idof_by_dimension,
    base::_first_inod_by_dimension_internal,
    base::_first_inod_by_dimension);
}
template<class T>
void
basis_P0<T>::_initialize_data(
    reference_element hat_K) const
{
    switch (hat_K.variant()) {
      case reference_element::p: {
        return basis_P0_p<T>::hat_node (_hat_node[hat_K.variant()]);
      }
      case reference_element::e: {
        return basis_P0_e<T>::hat_node (_hat_node[hat_K.variant()]);
      }
      case reference_element::t: {
        return basis_P0_t<T>::hat_node (_hat_node[hat_K.variant()]);
      }
      case reference_element::q: {
        return basis_P0_q<T>::hat_node (_hat_node[hat_K.variant()]);
      }
      case reference_element::T: {
        return basis_P0_T<T>::hat_node (_hat_node[hat_K.variant()]);
      }
      case reference_element::P: {
        return basis_P0_P<T>::hat_node (_hat_node[hat_K.variant()]);
      }
      case reference_element::H: {
        return basis_P0_H<T>::hat_node (_hat_node[hat_K.variant()]);
      }
      default : {
        error_macro ("hat_node: unsupported `" << hat_K.name() << "' element type");
      }
    }
}
// instantiation in library:
template class basis_P0<Float>;
} // namespace rheolef
